package com.sportradar.unifiedodds.restfuloddscache.oddsviewer;

import java.io.IOException;
import java.util.List;

import org.eclipse.jetty.websocket.api.Session;
import org.eclipse.jetty.websocket.api.annotations.OnWebSocketClose;
import org.eclipse.jetty.websocket.api.annotations.OnWebSocketConnect;
import org.eclipse.jetty.websocket.api.annotations.OnWebSocketMessage;
import org.eclipse.jetty.websocket.api.annotations.WebSocket;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@WebSocket
public class OddsWebSocket {

	private static final Logger logger = LoggerFactory.getLogger("roc");

	private Session session = null;
	private String eventid = null;

	@OnWebSocketMessage
	public void onText(Session session, String message) throws IOException {
		logger.info("Message received:" + message);
		logger.info("session: " + session);
	}

	@OnWebSocketConnect
	public void onConnect(Session session) throws IOException {
		this.session = session;
		List<String> eventId = session.getUpgradeRequest().getParameterMap().get("eventid");
		if (eventId != null && !eventId.isEmpty()) {
			this.eventid = eventId.get(0);
			logger.info("Eventid: " + this.eventid);
		}
		logger.info(session.getRemoteAddress().getHostString() + " connected!");
		logger.info("session: " + session);
		OddsViewerLogic.getInstance().join(this);
	}

	@OnWebSocketClose
	public void onClose(Session session, int status, String reason) {
		logger.info(session.getRemoteAddress().getHostString() + " closed!");
		logger.info("session: " + session);
		OddsViewerLogic.getInstance().part(this);
	}

	public Session getSession() {
		return session;
	}

	public String getEventid() {
		return eventid;
	}
}
